; Orlovskij G.V., Vved. v arkhit. MP 80386; SPB, 1992;
; prilozh.4: avt. - Wills D.C.
; Ispol`z: MASM, ver.5.10; LINK, ver.3.65. U avtora rekomend.
; masm art,art,art /MX  i  link art /MA /LI /NOE  ,
; no *.EXE, poluch. s etimi kl`uchami i bez nikh, ident.
; TASM 2.0 tryeb. MASM51, a dlya lokal.myetok - tzh. QUIRKS, no -> error -
; nekorr. pereopr. param.segmenta '_text' i warnings po pov. nekorrekt. align.
; (Byli tzh. 2 warning'a ob ispol`z.zarezerv.imyon - ustran.).
; Zatyk. 1-ye opis. segm-ta _text (pust.) -> TASM -> 2 warning'a;
; TLINK -> *.EXE. Zatyk.oba align -> ident. *.EXE; zapusk -> Except./Fault #8.
;	MASM51
;	QUIRKS
	.model	medium,c
	.386P
_data	segment	word use16 public 'data'
_data	ends
_const	segment	word use16 public 'const'
_const	ends
bss	segment	word use16 public 'bss'
bss	ends
dgroup_	segment word use16 public 'last'
dgroup_end label byte
dgroup_	ends
dgroup	group	_data,_const,bss,dgroup_
	assume	ds:dgroup
; ------
itext	segment	para use16 public 'code'
itext	ends

itext_	segment	para use16 public 'code'
itext_end label byte
itext_	ends
; ------
	assume	ds:idata,ss:idata
idata	segment word use16 stack
msgNoVM db	'Unable to enter protected mode.$'
	dw	100h dup (?)
unstack	label	word
idata	ends
idata_	segment	word use16
idata_end label byte
idata_	ends
; ------
_text	segment para use16 'code'
_text	ends
_text_	segment para use16 'code'
_text_end label byte
_text_	ends
; ------
_data	segment	word use16 public 'data'
; tipy sist.deskript.
tss	equ	1
ldt	equ	2
tss_busy equ	3
call_gate equ	4
task_gate equ	5
int_gate equ	6	; shlyuz pr`er.286
trap_gate equ	7
xtss	equ	9	; svob. TSS 386
xtss_busy equ	0Bh	; ??? - PROVERITH.
xcall_gate equ	0Ch
xint_gate equ	0Eh
xtrap_gate equ	0Fh
; ------
; tipy deskr-rov.
rdonly	equ	10h
rd_wr	equ	12h
rd_wr_xd equ	16h	; to zhe ss rasshir.vniz
exonly	equ	18h
ex_rd	equ	1Ah
exonly_cf equ	1Ch
ex_rd_cf equ	1Eh
; ------
gdlimit	macro	granularity,default,highlimit
	db	(granularity shl 7) or (default shl 6) or (highlimit and 0Fh)
	endm
pltype	macro	privilege,type
	db	80h or (privilege shl 5) or type
	endm
; -------
	assume	ds:dgroup
	align	16
gdt	label	byte
; -------
	dq	0
; ------
	dw	(gdt_size shl 3)-1
	dw	offset dgroup:gdt
	gdlimit	0,0,0
	pltype	0,rd_wr
	dw	dgroup
; ------
	dw	(idt_size shl 3)-1	; 10 data
	dw	offset dgroup:idt
	gdlimit	0,0,0
	pltype	0,rd_wr
	dw	dgroup
; -----
x_dgroup =	$-gdt	; 18 data
	dw	(offset dgroup:dgroup_end)-1
	dw	0
	gdlimit	0,0,0
	pltype	0,rd_wr
	dw	dgroup
; ------
	dw	(offset dgroup:dgroup_end)-1	; 20 data
	dw	0
	gdlimit	0,0,0
	pltype	0,rd_wr
	dw	dgroup
; ------
	dw	(offset idata:idata_end)-1	; 28 data
	dw	0
	gdlimit	0,0,0
	pltype	0,rd_wr
	dw	idata
; ------
	dw	(offset itext:itext_end)-1	; 30 data
	dw	0
	gdlimit	0,0,0
	pltype	0,exonly
	dw	itext
; ------
	dq	0	; 38(0) - rezervir. pod int 15h
; ------
x_crt	=	$-gdt	; 40 data
	dw	0FFFFh
	dw	0
	GDLIMIT	0,0,0
	pltype	0,rd_wr
	dw	0B800h
; ------
x_text	=	$-gdt	; 48 code
	dw	(offset _text:_text_end)-1
	dw	0
	gdlimit	0,0,0
	pltype	0,ex_rd
	dw	_text
; ------

x_tss	=	$-gdt	; 50 data - TSS glavn.zadachi
	dw	offset dgroup:task_end-offset dgroup:task-1
	dw	offset dgroup:task
	gdlimit	0,0,0
	pltype	0,XTSS
	dw	dgroup
; ------
x_PC	=	$-gdt	; 58
	dw	0FFFFh
	dw	0
	gdlimit	1,0,0
	pltype	0,rd_wr
	dw	0
; ------
gdt_size =	(($-gdt) shr 3)	; kol-vo el-tov GDT
; -----------------------
	align	16
idt	label	byte
; -------
; konstrukts. IRP rab.po tipu: irp z,<00,01,02>/ db &z/ endm -
; razvern`otsa v db 00/ db 01/ db 02. Ili: vmesto db &z napishem
; mov ax,offset h&z -  budet iskat` metki h00, h01, h02 i sozdast kom-dy
; zan`es. ikh adresov v AX. ',,' -> pust.slovo (h&z -> 'h'). '??' -
; fragm. dopustimogo im`eni 'fault??'.
; Kazhd. "arg-t" v IRP -> 8 bajtov=4 slova: smeshch., sootv. metkam tipa
; fault02; 0048h - smeshch.deskr-ra x_text v GDT; 8E00h; 0.
	irp	z,<00,01,02,03,04,05,06,07,08,09,10,11,12,13,14,??,16>
; v knig`e vm. 00 - pust.slovo - ochev., osh.
	dw	offset _text:fault&z,x_text,(xint_gate or 80h) shl 8,0
	endm
; 17,18,...,31.
	irp	z,<??,??,??,??,??,??,??,??,??,??,??,??,??,??,??>
	dw	offset _text:fault&z,x_text,(xint_gate or 80h) shl 8,0
	endm
; appar.prer.
	irp	z,<00,01,02,03,04,05,06,07,08,09,10,11,12,13,14,15>
	dw	offset _text:inthw&z,x_text,(xint_gate or 80h) shl 8,0
	endm
; -----
idt_size =	(($-idt) shr 3) ; kol-vo el-tov IDT
; -----------------------
task	db	68h dup (?) ; neinicializ.blok TSS
iobase	dw	offset virtual_io-offset task
virtual_io db	256 dup (0) ; vse porty razresh.
	dd	-1	; final`n. dw. slovo
task_end label	byte
; ------
	dw	512 dup (?) ; stek dl`a koda ur.0
stack0	label	word
cursor	label	word
cury	db	0
curx	db	0
fault	db	'Fault/Exception #',0
buffer	db	10 dup (?)
hex_xlt	db	'0123456789ABCDEF'
stepflag dw	0
_data	ends
; -------
_text	segment	para use16 public 'code'
 assume	cs:_text,ds:nothing,es:nothing,fs:nothing,gs:nothing,ss:dgroup
_dataseg	dw	x_dgroup
crtseg	dw	x_crt
pcseg	dw	x_pc
; -------
; ekv-sti dl`a emulateint, fault13 i intvm.
Zgs	equ	[bp+40]	; v86 gs iz shl`uza prer.
Zfs	equ	[bp+36]
Zds	equ	[bp+32]
Zes	equ	[bp+28]
Zss	equ	[bp+24]
Zsp	equ	[bp+20]
Zflags  equ     [bp+16]
Zcs	equ	[bp+12]
Zip	equ	[bp+8]
Zdword	equ	[bp+4]
Zebp	equ	[bp]
Zeax	equ	[bp-4]
Zebx	equ	[bp-8]
; -----
fejmp	macro	lbl,nptr,jump
; ot Fault/Exception Jump.
; napr., fejmp 02,2,intvm -> fault02: push dword ptr 2/ jmp intvm ->
; 6A02EBXX ili 6A02E9XXXX v zav. ot rasst. do intvm, a na fault02 mozhno ss.
fault&lbl: push dword ptr nptr
	jmp	jump
	endm
hijmp	macro	lbl,nptr,jump
; ot Hardware Interrupt Jump. Analog. predyd., no imyena myetok - inthw02 etc.
inthw&lbl: push	dword ptr nptr
	jmp	jump
	endm
; -------
emulateint:
	sub	eax,eax
	mov	ebx,fs:[ebx*4+eax]	; poluch.vekt.DOS
	mov	ax,bx
	shr	ebx,16
	xchg	bx,[Zcs]
	xchg	ax,[Zip]
	shl	ebx,16
	mov	bx,ax	; ebx=seg:smeshch
	sub	word ptr [Zsp],6
	mov	ax,[Zss]
	shl	eax,4
	add	eax,[Zsp]
	mov	fs:[eax],ebx
	mov	bx,[Zflags]
	mov	fs:[eax+4],bx
	and	dword ptr [Zflags],not((1 shl 8) or (1 shl 9) or (1 shl 16))
	pop	ebx
	pop	eax
	pop	ebp
	add	esp,4
	btr	[stepflag],0	; nuzhen poshag.rezhim?
	jc	fault01
	iretd
; -------
intvm:
	test	byte ptr [esp+12+2],1 shl 1 ; prov.flags - prishli li iz VM.
	jz	fail
	push	ebp
	mov	ebp,esp
	push	eax
	push	ebx
	mov	ebx,[Zdword]
	mov	fs,[pcseg]
	jmp	emulateint
; ------
fault13:
	test	byte ptr [esp+12+2],1 shl 1 ; VM li
	jz	faultgp
	push	ebp
	mov	ebp,esp
	push	eax
	push	ebx
	mov	fs,[pcseg]
	movzx	eax,word ptr [Zcs]
	shl	eax,4
	add	eax,[Zip]
	movzx	ebx,word ptr fs:[eax]
	cmp	bl,0CDh		; int n li
	jnz	$other
	shr	ebx,8		; udal. CD, vektor - v BL
	add	word ptr [Zip],2	; propusk.kom-du Int n
	btr	word ptr [Zflags],8
	setc	byte ptr [stepflag]
	jmp	emulateint
; -------
$other:
	pop	ebx
	pop	eax
	pop	ebp
	jmp	faultgp
; -------
; osh.i osob.sit., otl. ot GP(13).
; kazhd.fejmp (Fault/Excep.Jump) razvorach. v 4..5 bajtov koda -
; myetka, push dword ptr i jmp, sm.tekst makrosa.
	fejmp	00,0,intvm	; osh.d`el.
	fejmp	01,1,intvm	;
	fejmp	02,2,intvm	; NMI
	fejmp	03,3,fail	;
	fejmp	04,4,fail	;
	fejmp	05,5,fail	;
	fejmp	06,6,fail	; nedopust.kod kom-dy
	fejmp	07,7,fail	;
	fejmp	08,8,failec	; dvojn.osh.
	fejmp	09,9,fail       ;
	fejmp	10,10,failec	;
	fejmp	11,11,failec	;
	fejmp	12,12,failec	;
	fejmp	GP,13,failec	; GP=General Protection - obshch.osh.zashch.
	fejmp	14,14,failec	;
	fejmp	16,16,fail	;
	fejmp	??,32,fail	; neizv.osob.situats.
; ------
; appar.prer.                     
; kazhd. hijmp (Hardw.Interr.Jump) razvor. v 5 bajtov koda -
; myetka, push dword ptr i jmp., sm. tekst makrosa.
	hijmp	00,08h,intvm	; prer.ot tajmera
	hijmp	01,09h,intvm	; prer. ot klav.
	hijmp	02,0Ah,intvm	;
	hijmp	03,0Bh,intvm	;
	hijmp	04,0Ch,intvm	;
	hijmp	05,0Dh,intvm	;
	hijmp	06,0Eh,intvm	;
	hijmp	07,0Fh,intvm	;
	hijmp	08,70h,intvm	;
	hijmp	09,71h,intvm	;
	hijmp	10,72h,intvm	;
	hijmp	11,73h,intvm	;
	hijmp	12,74h,intvm	;
	hijmp	13,75h,intvm	;
	hijmp	14,76h,intvm	;
	hijmp	15,77h,intvm	;
; -------
failec:
	xchg	[esp+4],eax
	shl	eax,16
	or	eax,1 shl 15
	or	ax,word ptr [esp]
	xchg	[esp+4],eax
	add	esp,4
fail:
	xchg	[esp],eax
	pushad
	push	ds
	push	es
	mov	ebp,esp
	mov	ds,[_dataseg]
	mov	es,[_dataseg]
	assume	ds:dgroup, es:dgroup
	mov	si, offset dgroup:fault		; soob.ob osh.
	push	eax
	push	ax
	call	showmsg
	pop	ax
	aam
	add	ax,('0' shl 8)+'0'	; perev.v ASCII
	xchg	al,ah
	call	showchar
	xchg	al,ah
	call	showchar
	mov	al,' '
	call	showchar
	pop	eax
	test	ax,1 shl 15
	jz	@F
	mov	al,'('
	call	showchar
	shr	eax,16	; teper` kod osh. - v ax
	call	showwordh
	mov	al,')'
	call	showchar
	mov	al,' '
	call	showchar
@@:	mov	al,'@'		; ili @:@: ?
	call	showchar
	mov	ax,[bp+40]	; ip
	call	showwordh
	mov	al,' '
	call	showchar
	mov	cx,40
	mov	si,bp
@@:	lodsw			; ili @@: ?
	call	showwordh
	mov	al,':'
	call	showchar
	loop	@B
@@:	jmp	@B	; "myortv.pyetlya" - ??? Ili @@: ?
; --------
showwordh:
	push	si
	mov	dx,ax
	mov	di,offset dgroup:buffer
	mov	si,di
	mov	bx,offset dgroup:hex_xlt
call	wordh
	mov	byte ptr es:[di],0
	call	showmsg
	pop	si
	ret
; ------
wordh:
	mov	al,dh
	call byteh
	mov	al,dl
byteh:
	push	ax
	shr	al,4
	xlat
	stosb
	pop	ax
	and	al,0Fh
	xlat
	stosb
	ret
; ------
	assume ds:dgroup,es:nothing
showchar:
	push	ax
	push	es
	call	getpos
	mov	ah,7
	stosw
	call	getpos
	mov	ah,7	; atrib.
	stosw
	call	setpos
	pop	es
	pop	ax
	ret
; -------
	assume	ds:dgroup,es:nothing
showmsg:
	push	es
	call	getpos
	mov	ah,7
	jmp	short $chst
@@:	stosw
$chst:	lodsb
	or	al,al
	jnz	@B
	call	setpos
	pop	es
	ret
; ------
	assume	ds:dgroup,es:nothing
getpos:
	push	ax
	mov	es,[crtseg]
	mov	al,[cury]
	mov	ah,80*2
	mul	ah
	mov	di,ax
	movzx	ax,[curx]
	shl	ax,1
	add	di,ax
	pop	ax
	ret
; -----
	assume	ds:dgroup,es:nothing
setpos:
	push	cx
	shr	di,1	; k simvolam
	mov	ax,di
	mov	cl,80
	div	cl	; simv/strok
	pop	cx
	mov	[cursor],ax
	ret
; -----
_text	ends
; ---------
itext	segment	para use16 public 'code'
; glavn. vkhod v prog.
	assume	cs:itext,ds:nothing,es:nothing,ss:idata
start:
	mov	ax,3
	int	10h
	mov	ax,dgroup
	mov	ds,ax
	mov	es,ax
	assume	ds:dgroup,es:dgroup
	mov	si,offset idt
	mov	cx,idt_size
	call	adjust
	mov	si,offset gdt
	mov	cx,gdt_size
	call	adjust
; podg.vkh.inf. i obr. k int 15-89.
	mov	si,offset gdt
	mov	bh,20h
	mov	bl,28h	; bylo bh - ochev., osh.
	mov	ah,89h
	mov	cx,0FFFFh
	loop	$
ready:	int	15h	; ???
	jc	failpm
 assume	cs:itext,ss:nothing,ds:nothing,es:nothing,fs:nothing,gs:nothing
	sub	ebx,ebx
        call    pisk       ; dlya indikats.
	mov	bx,offset dgroup:stack0
	mov	ax,x_dgroup
	mov	ss,ax
	mov	esp,ebx
	mov	ds,ax	; (ili es ???)
	assume	ss:dgroup,ds:dgroup
	mov	ax,x_tss
	ltr	ax
	sub	ax,ax
	lldt	ax	; ldt net
	mov	word ptr [task+08h],ss
	mov	word ptr [task+04h],sp
	mov	ax,[iobase]
	mov	word ptr [task+66h],ax ; ???
	sub	eax,eax
	mov	ax,idata
	push	eax
	push	eax	; fs
	push	eax	; ds
	push	eax
	push	eax
	mov	ax,offset idata:unstack ; ??? - bylo ustack
	push	eax
	mov	eax,(11b shl 12) or (1 shl 17)	; ust.VM, IOPL=3
	push	eax
	xor	eax,eax
	mov	ax,itext
	push	eax
	mov	ax,offset vmstart
	push	eax
	clts
	sub	eax,eax
	push	eax
	popfd
	iretd		; v virt.rezhim
 assume	cs:itext,ss:nothing,ds:nothing,es:nothing,fs:nothing,gs:nothing
vmstart:
	xor	al,al
	out	21h,al
	out	0A1h,al
	sti
	mov	ah,31h	; TSR
	mov	dx,400h	; 16K
	int	21h
; -------
failpm:
	mov	ax,idata
	mov	ds,ax
	assume	ds:idata
	mov	ah,9	; vyv.soobshch.
	int	21h
	mov	ax,4C01h
	int	21h
; --------
	assume	cs:itext,ds:nothing
adjust:
	add	si,2
	mov	di,si
	lodsw		; beryom smyeshch.
	movzx	edx,ax
	lodsw
	mov	bx,ax
	lodsw		; zagr.bazu segm.
	test	bh,00010000b	; deskr.segm.?
	jnz	@F
	test	bh,00000100b	; shlyuz?
	jnz	adjust
@@:	movzx	eax,ax
	shl	eax,4
	add	eax,edx
	stosw
	shr	eax,16
	xchg	ah,bh	; ??? - bylo bx
	stosw		; 0 v starsh.chast` lin.adr.
	mov	ax,bx
	stosw
	loop	adjust
	ret
; ------
pisk:
	mov	dx,0200h
@@:
	in	al,61h
	or	al,02h
	out	61h,al
	mov	cx,0100h
	loop	$
	in	al,61h
	and	al,0FDh
	out	61h,al
	mov	cx,100h
	loop	$
	dec	dx
	cmp	dx,0
	jne	@B
        ret
; ------
itext	ends
; ------
	end	start
