; Bramm P., Mikroprots. 80386 ... .
; uzhe saditsa, no int 00h -> posle dampa - perezagr.; zatknuto, chtoby zavis.
	.286P

opsize	MACRO
	db	66h
	ENDM

segadr	MACRO	segr
	db	66h
	sub	ax,ax
	mov	ax,&segr
	db	66h
	shl	ax,4
	ENDM

settssa	MACRO	reg,tss,seg
	db	66h
	lea	reg&x,&tss
	db	66h
	add	reg&x,ax
	mov	seg&.base_1,reg&x	; ml.16 bit lin.adr.
	db	66h
	shr	reg&x,8
	mov	seg&.base_m,reg&h
	ENDM

segcvt	MACRO	segr,segm
	segadr	segr
	mov	segm&.base_1,ax		; baza dann. supervizora
	db	66h
	shr	ax,8
	mov	segm&.base_m,ah
	ENDM	

desc	struc		; opis.strukt. deskriptora - sr.: Shagurin, s.110.
limit	dw	0
base_1	dw	0
base_m	db	0
access	db	0
gran	db	0
base_h	db	0	
	desc	ends

stkdef	struc
oldip	dw	0
	dw	0
oldcs	dw	0
	dw	0
oldfl	dw	0
	dw	0
oldsp	dw	0
	dw	0
oldss	dw	0
	dw	0
oldes	dw	0
	dw	0
oldds	dw	0
	dw	0
oldfs	dw	0
	dw	0
oldgs	dw	0
	dw	0				
	stkdef	ends

code	segment	para public 'CODE'
	assume	cs:code,ds:code,ss:code
	org	100h

begin:
begin1	proc	far
	jmp	segsetup

	org	begin+10h
	db	2000h dup (2Eh)	; mesto dl`a steka

gdt_def	desc	<>			; 1-j deskr. - pust.
ref_13	desc	<7,0,0,0E2h,0,0>	; pust. LDT urovn`a 3.
ref13	equ	ref_13-gdt_def+3
ref_10	desc	<7,0,0,82h,0,0>		; pust. LDT urovn`a 0.
ref10	equ	ref_10-gdt_def
ref_d	desc	<0FFFFh,0,0,92h,0Fh,0>	; dannyje
ref_dta	equ	ref_d-gdt_def
ref_dd	desc	<0FFFFh,0,0,92h,0Fh,0>	
ref_dtad equ	ref_dd-gdt_def
ref_zer	desc	<0FFFFh,0,0,92h,0Fh,0>
ihzero	equ	ref_zer-gdt_def
stk_data desc	<0FFFFh,0,0,92h,0Fh,0>	; stek kak dannyje
stkdata	equ	stk_data-gdt_def
	desc	<0,0,0,96h,0,0>
ref_0	desc	<sz386t-1,0,0,89h,00h,0>
ref0d	equ	ref_0-gdt_def
ref_1	desc	<sz386t-1,0,0,89h,00h,0> ; zadacha 80386
ref1d	equ	ref_1-gdt_def
v86_0	desc	<szv86t,0,0,0EBh,00h,0>	; zadacha v86
v860d	equ	v86_0-gdt_def+3
sup_c	desc	<0FFFFh,0,0,9Ah,0Fh,0>
supcd	equ	sup_c-gdt_def
sup_d	desc	<0FFFFh,0,0,92h,0Fh,0>	; ne opisano v knige
supdd	equ	sup_d-gdt_def
sup_s	desc	<0,0,0,96h,00h,0>
supsd	equ	sup_s-gdt_def
exe_c	desc	<0FFFFh,0,0,9Ah,0Fh,0>
execd	equ	exe_c-gdt_def
exe_d	desc	<0FFFFh,0,0,92h,0Fh,0>
exedd	equ	exe_d-gdt_def
; stranno - propusk. 2190. Vozm., v kn. - osh. v schotchike.
exe_s	desc	<0,0,0,96h,00h,0>
exesd	equ	exe_s-gdt_def
d_B800	db	0FFh,0FFh,00h,80h,0Bh,92h,00h,00h
s_B800 equ	d_B800-gdt_def
; konets GDT.

gdt_size equ	$-gdt_def	; ili &-gdt_def

	.SALL		; supress all macro expansions
idt_def	equ	$		; ili &
	REPT	256
	desc	<0,supcd,0,8Eh,0,0>
	ENDM

idt_size equ	$-idt_def	; ili&-idt_def

tss_d	struc
back	dw	0
	dw	0
esp0	dd	400h
ss0	dw	supsd
	dw	0
esp1	dd	400h
ss1	dw	supsd
	dw	0
esp2	dd	400h
ss2	dw	supsd
	dw	0
tcr3	dd	0
teip	dw	0
	dw	0
teflags	dw	2
	dw	0
teax	dw	0
	dw	0
tecx	dw	0
	dw	0
tedx	dd	0
tebx	dd	0
tesp	dw	100h,0
tebp	dd	0
tesi	dd	0
tedi	dd	0
tes	dw	supdd
	dw	0
tcs	dw	supcd
	dw	0
tss	dw	supsd
	dw	0
tds	dw	supdd
	dw	0
tfs	dw	0
	dw	0
tgs	dw	0
	dw	0
tldt	dw	ref10
	dw	0
	dw	0
iomap	dw	104
	tss_d	ends

supv	tss_d	<>
sz386t	equ	$-supv
supv2	tss_d	<v860d>
v86	tss_d	<>
	dw	4096 dup (0)	; bitov.karta vv/v, vse bity =0.
szv86t	equ	$-v86
	dw	-1	; bajt ed-ts - konets karty vv/v.

dtsize	dw	0 
dtload	dd	0
intcd1	dw	0
intcd2	dw	0

debugf	db	0
debugf0 db	0
debugf0a db	0
debugf1	db	02
debugf1a db	0
debugf1b db	0
retdisp	dw	0
dsaddr	dw	0,0
dumpcd1	dw	0
success	db	'virtual 8086 mode is established! '
	db	'Enter G (go) or D - $'
newline	db	0Dh,0Ah,'$'
endad	db	0
datasrz	equ	$-gdt_def+15
ihspv	equ	1800h
ihspn1	equ	ihspv-size stkdef
ihspn2	equ	ihspn1-4

segsetup:
	mov	cx,10h
hua:
	mov	al,34h
	call	printc
	loop	hua	
	mov	ax,cs
	mov	ss,ax
	mov	sp,2000h
	mov	ds,ax
	mov	es,ax
; ---------
; shag 9: komponovka i zapoln. deskr. segm. dl`a zadachi 80386.
	cld
	cli
; shag 9A: preobr. sod. reg. razl. segm. v lin. adr. v deskr-rakh.
	segcvt	ds,sup_d
	segcvt	cs,sup_c
	segcvt	ss,sup_s
	segcvt	ss,stk_data
	segadr	ds
	opsize
	mov	dsaddr,ax
; shag 9B: zapis` smeshch.obr-chikov prer. v ikh deskr-ry.
; predp., chto deskr. i obr-ki generir-tsa otdel`n. gruppami
; i vnutri kazhd. gruppy primyk. drug k fr.
	sub	bx,bx
	lea	ax,int_hand0
	mov	cx,256
fillihd1:
	mov	idt_def.limit[bx],ax ; ?
	add	ax,4
	add	bx,8
	loop	fillihd1
	segadr	ds
; shag 9C: preobr. lin.adr.oblastej dann. dl`a zap.deskr.segm.,
; napr., deskr. TSS i LDT.
	settssa D,supv,ref_0
	settssa	D,supv2,ref_1
	settssa	D,v86,v86_0
	settssa	D,gdt_def,ref_13
	settssa	D,gdt_def,ref_10
; ------------
; shag 10. zapoln. selekt.segmentov obr.prer. v TSS 80386.
	mov	supv.tcs,supcd
	mov	ax,supdd
	mov	supv.tds,ax
	mov	supv.tes,ax
	mov	supv.tfs,ax
	mov	supv.tgs,ax
	mov	supv.tss,supsd
	mov	ax,ref10
	mov	supv.tldt,ax
	mov	supv2.tldt,ax
; ----------------
; shag 11: zap.reg. prog,steka i flagov.
	opsize
	sub	ax,ax
	mov	ax,01200h
	opsize
	mov	supv.tesp,ax
	mov	ax,offset instexe
	opsize
	mov	supv.teip,ax
	mov	supv.ss0,supsd
	mov	word ptr supv.esp0,800h
	mov	supv.ss1,supsd
	mov	word ptr supv.esp1,800h
	mov	supv.ss2,supsd
	mov	word ptr supv.esp2,800h
; -------------
; shag 12 - nastr. TSS virt. 8086. Kopir. aktiv. sredu real.rezhima 8086,
; k-ryj sejchas ust., v TSS zadachi V86.
	mov	ax,ds
	mov	v86.tes,ax
	mov	v86.tds,ax
	mov	v86.tfs,ax
	mov	v86.tgs,ax
	mov	ax,ss
	mov	v86.tss,ax
	mov	ax,cs
	mov	v86.tcs,ax
; ust.selekt. i ukaz. segm.steka obr-chika prer.urovn`a 0; 
; dl`a polnoty - tzh. 1 i 2. Ust.tk.mladsh.16 razr. ESP - starsh.=0.
	mov	v86.ss0,supsd
	mov	word ptr v86.esp0,ihspv
	mov	v86.ss1,supsd
	mov	word ptr v86.esp1,1600h
	mov	v86.ss2,supsd
	mov	word ptr v86.esp2,1400h
; ust.reg.dl`a prodolzh.rezhima 8086 - IP i SP.
	opsize
	sub	ax,ax
	mov	ax,offset resume
	opsize
	mov	v86.teip,ax
	mov	ax,sp
	opsize
	mov	v86.tesp,ax
; ust. eflags v TSS, chtoby prodolzh.v rezh.v86.
	mov	v86.teflags,0011001000000010b
; flagi			    NI00DITSZ A PC
;			     PL
	mov	v86.teflags+2,00000000000000010b
; flagi					VR
;					M
; VM ustanavl., IOPL=3,prer.razresh.
	mov	v86.iomap,sz386t	; smeshch.k tab.v/v
; ust.znach.LDT v TSS zadachi
mov	v86.tldt,ref13	; LDT urovn`a 3.
; ------------
; shag 13. Ust.reg.80386 dl`a vyp. v zashchishch.rezh.
; ust. reg-rov GDT i IDT.
	opsize
	mov	ax,dsaddr
	opsize
	sub	bx,bx

	lea	bx,gdt_def
	opsize
	add	bx,ax
	opsize
	mov	word ptr dtload,bx
	mov	dtsize,gdt_size-1
	LGDT	fword ptr dtsize
	opsize
	sub	bx,bx
	lea	bx,idt_def
	opsize
	add	bx,ax
	opsize
	mov	word ptr dtload,bx
	mov	dtsize,idt_size-1
	LIDT	fword ptr dtsize
; ---------------
; shag 14. Sreda 80386 ust. na perekh. v zashchishch.rezh.
	db	0Fh,20h,0C0h	; mov	eax,cr0
	or	al,1
	db	0Fh,22h,0C0h	; mov	cr0,eax
	jmp	short local_	; ochist.ochered`.
local_:
; teper` prog. vyp. v zashchishch.rezh.
	mov	ax,ref10
	lldt	ax
	cmp	debugf,0
	je	skip01
	call	edump
	call	newln
skip01:
	mov	ax,supdd
	mov	ds,ax
	mov	es,ax
	db	8Eh,0E0h	; mov fs,ax
	db	8Eh,0E8h	; mov gs,ax
	mov	ax,supsd	; deskr.steka 386.
	mov	ss,ax
	db	0EAh
	dw	godoit-begin+100h,supcd
; -------------
; shag 15. Vse deskr. imejut f-t 80386, dazhe CS. 
; Ust. flag NT i perejd`om na zadachu v86.
godoit:
mov	cx,ref1d
	call	pisk	; rabot.
	ltr	cx
;	call	pisk	; uzhe ne rabot.
	opsize
	pushf
	opsize
	pop	ax
	or	ah,40h	; flag vlozhenn.zadachi
	opsize
	push	ax
	opsize
	popf
; teper` perejd`om v rezh.V86, ispol`zuja IRET.
; Tsepochka vozvr. - v nash. TSS, i flag NT vyzovet perekh.
	iret
; ------------
; shag 16. Teper` my v rezh. V86.
resume:
resumed	equ	resume-begin+100h
	cld	; pr`am.napr.
resloop:
	lea	dx,success
	mov	ah,9
	int	21h
	mov	ah,1
	int	21h
	push	ax
	lea	dx,newline
	mov	ah,9
	int	21h
	pop	ax
	cmp	al,'G'
	je	todos	
	cmp	al,'D'
	jne	resloop
	mov	debugf0,3
	jmp	resloop
todos:
	lea	dx,totalsize+20Fh
	shr	dx,4
	mov	ah,31h	; ost.v pam.
	int	21h
; -------------------
; obsluzh.prog-ma.
int_hand0:	
	REPT	256
	call	ih_common	; 3-bajtn.vyz.
	iret	; 1-bajtn.vozvr.iz prer.
	ENDM

ih_common:
	push	ax
	mov	ax,supdd
	mov	ds,ax
	pop	ax
	pop	retdisp
	cmp	sp,ihspn2
	jne	ihcommn
	pop	intcd1
	pop	intcd2
ihcommn:
	pusha
	mov	ax,stkdata
	mov	es,ax
	mov	bx,sp
	mov	ax,es:[bx+26]	; ? - starsh.slovo eflags
	and	al,2
	jnz	stillok
	mov	debugf0,3
	mov	debugf0a,3
stillok:
	mov	dx,ds
	mov	es,dx
	cmp	debugf0,0
	je	skip02
	cmp	debugf0,1
	jne	fulld02
	mov	ax,retdisp	; poluch.Nr prer.
	call	mindump
	jmp	skip02
fulld02:
	cmp	debugf0,2
	je	fulld02e
	mov	debugf0,0
; nuzhen dopoln.stek na sluch.avar.situats.
	mov	ax,stkdata
	mov	ds,ax
	mov	ax,780h
	mov	cx,8
badstk0:
	call	dumpln
	loop	badstk0
	call	newln
	mov	ax,1780h
	mov	cx,8
badstk1:
	call	dumpln
	loop	badstk1
	call	newln
	mov	ds,dx
fulld02e:
	call	edump
skip02:
	mov	si,retdisp
	sub	si,int_hand0-begin+100h
	and	si,0FFFCh
; u nas - 83E6FC, u Bramma -81E6FCFF; oba var-ta rab-spos.
	mov	retdisp,si
	mov	ax,stkdata
	mov	es,ax
	mov	bx,sp
	add	bx,16
	cmp	si,13*4	; eto prer.13?
	jne	notint13
	jmp	isint13
notint13:
	mov	ax,es:[bx].oldss	; ss zadachi v86
	mov	cl,ah
	shl	ax,4
	shr	cl,4
	mov	ref_d.base_1,ax
	mov	ref_d.base_m,cl
	mov	cx,es:[bx].oldsp
	sub	cx,6
	mov	es:[bx].oldsp,cx
	mov	bp,es:[bx].oldip
	mov	di,es:[bx].oldcs
	mov	ax,es:[bx].oldfl
	mov	dx,ref_dta
	mov	ds,dx
	xchg	bx,cx	; sp v86 - v bx i sokhr.deskr.steka
	mov	[bx],bp
	mov	[bx]+2,di
	mov	[bx]+4,ax
	and	ax,0FCFFh
	mov	bx,ihzero
	mov	ds,bx
	mov	bx,si
	mov	bp,[bx]
	mov	di,[bx]+2
	mov	bx,cx
	mov	es:[bx].oldfl,ax
	mov	es:[bx].oldip,bp
	mov	es:[bx].oldcs,di
rejoin:
	mov	dx,supdd
	mov	ds,dx
	mov	es,dx
	cmp	debugf0a,0
	je	skip03
	cmp	debugf0a,1
	jne	fulld02a
	mov	ax,bp
	call	mindump
	jmp	skip03
fulld02a:
	call	edump
	mov	ax,stkdata
	mov	ds,ax
	mov	bx,ihspn1
	mov	ax,[bx].oldss
	mov	bx,[bx].oldsp
	mov	ds,dx
	mov	cl,ah
	shr	cl,4
	mov	ref_d.base_m,cl
	shl	ax,4
	mov	ref_d.base_1,ax
	mov	ax,ref_dta
	mov	ds,ax
	mov	ax,bx
	mov	cx,4
dumpit380:
	call	dumpln
	loop	dumpit380
	mov	ax,supdd
	mov	ds,ax
	call	newln
	cmp	debugf0a,3
	jne	skip03
	mov	debugf0a,0
skip03:
	sub	ax,ax
	mov	ds,ax
	mov	es,ax
	popa
	opsize
	iret
; 3. Prer.13. Nado poluch. CS v86 v kach.deskr., chtoby prover, int ili iret.
isint13:
	mov	ax,es:[bx].oldcs
	mov	si,es:[bx].oldip
	mov	cl,ah
	shl	ax,4
	shr	cl,4
	mov	ref_d.base_1,ax
	mov	ref_d.base_m,cl
	mov	ax,ref_dta
	mov	ds,ax
	cld
	lodsb
	cmp	al,0CFh	; eto IRET ?
	je	prociret
	cmp	al,0CDh	; eto INT ?
	je	procint
; neozhid. - sdel.damp.
	mov	ds,dx
	call	edump
	mov	debugf0a,3
	mov	si,13*4
	jmp	notint13
; 4. Obrab.IRET.
	procint:
	lodsb
	mov	es:[bx].oldip,si
	mov	ds,dx
	mov	ah,0
	add	ax,ax
	add	ax,ax
	mov	si,ax
	jnz	notint00	; jesli ne int00
	mov	ax,es:[bx].oldss
	mov	supv.tecx,ax
	mov	cx,bx
	mov	bx,sp
	mov	ax,es:[bx+14]
	mov	supv.teax,ax
	mov	ax,es:[bx+10]
	mov	word ptr supv.tedx,ax
	mov	bx,cx
	db	09Ah
	dw	0,ref0d
	jmp	rejoin
notint00:
	jmp	notint13
; -----------
; 5. obr. iret.
prociret:
	mov	ds,dx
	mov	ax,es:[bx].oldss
	mov	cl,ah
	shr	cl,4
	shl	ax,4
	mov	ref_d.base_1,ax
	mov	ref_d.base_m,cl
	mov	cx,es:[bx].oldsp
	mov	ax,ref_dta
	mov	ds,ax
	xchg	bx,cx
	mov	ax,[bx]		; ip
	mov	si,[bx+2]	; cs
	mov	di,[bx+4]	; fg
	add	bx,6
	xchg	bx,cx
	mov	es:[bx].oldsp,cx
	mov	es:[bx].oldip,ax
	mov	es:[bx].oldcs,si
	mov	es:[bx].oldfl,di
	jmp	rejoin
; -------
; 6. zadacha zashchishch.rezhima 90386; obr.prer.V86-no vyz.jejo,
; kogda obnar. int00.
instexe	proc
instexeb:
	cmp	debugf1,0
	je	skip04
	cmp	debugf1,1
	jne	fulld04
	mov	ax,0E0Dh	; poluch.nomer int - ?
	call	mindump
	jmp	short skip04
fulld04:
	call	edump	
skip04:
	push	ax
	opsize
	sub	ax,ax
	mov	ax,cx ; ???
	opsize
	sub	cx,cx
	mov	cx,dx
	opsize
	shl	ax,4	; poluch. deskr. kak lin.adr.
	opsize
	add	ax,cx
	mov	exe_c.base_1,ax
	mov	exe_d.base_1,ax
	mov	exe_s.base_1,ax
	opsize
	shr	ax,8
	mov	exe_c.base_m,ah
	mov	exe_d.base_m,ah
	mov	exe_s.base_m,ah
	mov	bx,exedd
	mov	cx,exesd
	pop	ax
	db	09Ah
	dw	0,execd
	jnz	skipdmp
	call	edump
skipdmp:
	mov	ax,supdd
	mov	ds,ax
	mov	es,ax
	iret
	jmp	instexeb	; na nachalo - ?
instexe	endp
; ------
; prog. otladki.
; zapoln.deskr. v GDT lin. adresom segmenta (adr.v BX) i zagr. znach.deskr.
; v BP. Wyz. prog. peremestit ego (obychno) v DS, v rez.chego lin.adr.
; zagruzitsa iz GDT.
getdsv	proc
	opsize
	push	ax
	opsize
	sub	ax,ax
	mov	ax,bx
	opsize
	shl	ax,4
	mov	ref_dd.base_1,ax
	opsize
	shr	ax,8
	mov	ref_dd.base_m,ah
	mov	bp,ref_dtad	; poluch.znach.selekt.
	opsize
	pop	ax
	ret
getdsv	endp
; ------
counte	dw	0
printc	proc
; vyv.na pech.bajta iz al; al razrush.
;        call    pisk
	push	es
	push	cx
	push	bx
	push	dx
	mov	bx,s_B800
	mov	es,bx
	mov	bx,word ptr counte
	mov	byte ptr es:[bx],al
	mov	byte ptr es:[bx+1],07h
	cmp	word ptr counte,400h
	jge	zavis
	jmp	short prodo
zavis:	
	db	0FAh,0EBh,0FEh
prodo:
	add	word ptr counte,2
;	mov	dx,03BCh
;	out	dx,al
;	mov	bl,10h
;	sub	cx,cx
;	inc	dx
;busy1:
;	in	al,dx
;	test	al,80h
;	jnz	strobe
;	loop	busy1
;	dec	bl
;	jnz	busy1
;strobe:
;	mov	al,0Dh
;	inc	dx
;	out	dx,al
;	mov	cx,255
;sign1:
;	loop	sign1
;	dec	al
;	out	dx,al
	pop	dx
	pop	bx
	pop	cx
	pop	es
	ret
printc	endp
; ------
hexit	proc
; 16-i`n.cifra -> obychn.cifra i jejo pech.
	or	al,30h
	cmp	al,3AH
	jl	yes1
	add	al,7
	yes1:
	call	printc
	ret
hexit	endp
; --------
prtalx proc
; al -> 2 16-ichn.tsifry
	push	ax
	shr	al,4
	call	hexit
	pop	ax
	push	ax
	and	al,0Fh
	call	hexit
	pop	ax
	ret
prtalx	endp
; ----
prtaxx	proc
	push	ax
	push	ax
	mov	al,ah
	call	prtalx
	pop	ax
	call	prtalx
	pop	ax
	ret
prtaxx	endp
; ------
prteaxx	proc
	opsize
	push	ax
	opsize
	push	ax
	opsize
	shr	ax,16
	call	prtaxx
	opsize
	pop	ax
	call	prt16
	opsize
	pop	ax
	ret
prteaxx	endp
; -------
newln	proc
	push	ax
	mov	al,0Dh
	call	printc
	mov	al,0Ah
	call	printc
	pop	ax
	ret
newln	endp
; -----
dumpln	proc
; damp 16 bajtov, nach. s ds:ax; ax peredvig.
	push	bx
	push	cx
	push	ax
; lin.adr. - dla 8086 ili 80386; vybor. zav. ot togo, prevys.li DS
; gdt_size (chto obychno dolzh.byt).
	opsize
	sub	ax,ax
	opsize
	sub	bx,bx
	mov	bx,ds
	mov	ax,gdt_size
	opsize
	cmp	bx,ax
	jg	do8086
; mogli oshibitsa i poluch.musor, no obychno khorosho.
	push	es
	mov	ax,supdd
	mov	es,ax
	mov	ah,es:gdt_def.base_m[bx]
	opsize
	shl	ax,8
	mov	ax,es:gdt_def.base_1[bx]
	pop	es
	jmp	short dolinear
do8086:
	mov	ax,bx
	opsize
	shl	ax,4
dolinear:
	opsize
	sub	bx,bx
	pop	bx
	push	bx
	opsize
	add	ax,bx
	call	prteaxx
	mov	al,' '
	call	printc
	mov	cx,8
nxtword:
	mov	ax,[bx]
	add	bx,2
	xchg	al,ah
	call	prt16
	loop	nxtword
	mov	al,' '
	call	printc
	pop	bx
	mov	cx,16
nxtbyte:
	mov	al,[bx]
	inc	bx
	cmp	al,' '
	jl	isactl	; < -> '.' .
	cmp	al,07Eh
	jng	nothigh
isactl:
	mov	al,'.'
nothigh:
	call	printc
	loop	nxtbyte
	call	newln
	mov	ax,bx
	pop	cx
	pop	bx
	ret
dumpln	endp	
; ------
prt16	proc
; pech. ah v 16-ichn.forme i probel.
call prtaxx
	mov	al,' '
	call	printc
	ret
prt16	endp
; -----
dumprg	proc
	opsize
	push	ax
	call	newln
	opsize
	pushf
	call	prteaxx
	opsize
	mov	ax,bx
	call	prteaxx
	opsize
	mov	ax,cx
	call	prteaxx
	opsize
	mov	ax,dx
	call	prteaxx
	opsize
	mov	ax,bp
	call	prteaxx
	opsize
	mov	ax,sp
	call	prteaxx
	opsize
	mov	ax,si
	call	prteaxx
	opsize
	mov	ax,di
	call	prteaxx
	call newln
	mov	ax,cs
	call	prt16
	mov	ax,ds
	call	prt16
	mov	ax,es
	call	prt16
	mov	ax,ss
	call	prt16
	db	8Ch,0E0h	; fs
	call	prt16
	db	8Ch,0E8h
	call	prt16
	sldt	ax
	call	prt16
	str	ax
	call	prt16
	call	newln
	db	0Fh,20h,0Ch	; cr0
	call	prteaxx
	db	0Fh,20h,0Dh	; cr2
	call	prteaxx
	db	0Fh,20h,0D8h	; cr3
	call	prteaxx
	sgdt	fword ptr dtsize
	opsize
	mov	ax,word ptr dtload ; word?
	call	prteaxx
	sidt	fword ptr dtsize
	opsize
	mov	ax,word ptr dtload
	call	prteaxx
	opsize
	pop	ax	; -> eflags
	call	prteaxx
	call	newln
	opsize
	pop	ax
	ret
dumprg	endp
; -----
dmptss	proc
; damp TSS i jego steka (64 b.).
; pri vkh. cx=smeshch.k TSS.
	push	ax
	push	bx
	push	cx
	mov	ax,cx
	mov	cx,7
	dumpit2:
	call	dumpln
	loop	dumpit2
	call	newln
	pop	bx
	push	bx
	mov	cx,[bx].tss
	mov	dx,[bx].tesp
	mov	ax,[bx].teflags+2
	and	al,2	; vydel.flag v86
	jnz	short gotss
	and	cl,0F8h
	lea	BX,gdt_def
	add	bx,cx
	opsize
	mov	cx,[bx].base_1
	opsize
	shr	cx,4
gotss:
	mov	bx,cx
	call	getdsv
	mov	ds,bp
	mov	ax,dx
	mov	cx,4
dumpiss:
	call	dumpln
	loop	dumpiss
	mov	bx,supdd
	mov	ds,bx
	call	newln
	pop	cx
	pop	bx
	pop	ax
	ret
dmptss	endp
; -----
edump	proc
	pop	dumpcd1
	push	dumpcd1
	push	ax
	push	bx
	push	cx
	push	dx
	call	dumprg
	call	newln
	lea	ax,dtsize
	call	dumpln
	call	dumpln
	call	newln
	lea	ax,gdt_def
	mov	cx,(idt_def-gdt_def+31)/16
dumpitg:
	call	dumpln
	loop	dumpitg
	call	newln
	lea	cx,supv
	call	dmptss
	lea	cx,supv2	; ust.na TSS supv2
	call	dmptss
	lea	cx,v86
	call	dmptss
	call	newln
	mov	cx,6
	mov	ax,sp
	mov	bx,ss
	mov	ds,bx
dumpit30:
	call	dumpln
	loop	dumpit30
	mov	ax,supdd
	mov	ds,ax
	call	newln
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
edump	endp
; -----
mindump	proc
	opsize
	shl	ax,16
	pop	ax
	push	ax
	call	prteaxx
	call	newln
	opsize
	shr	ax,16
	ret
mindump	endp
; -----
pisk	proc
	push	dx
	push	ax
	push	cx
	mov	dx,0200h
pisk0:
	in	al,61h
	or	al,02h
	out	61h,al
	mov	cx,0100h
	loop	$
	in	al,61h
	and	al,0FDh
	out	61h,al
	mov	cx,100h
	loop	$
	dec	dx
	cmp	dx,0
	jne	pisk0
	pop	cx
	pop	ax
	pop	dx
;	db	0EBh,0FEh
        ret
pisk	endp
; -----
totalsize:

begin1	endp

code	ends
	end	begin
